%% IMPORT DATA %%

%% Import data from IMU
accelerometerX = double(data{4});
accelerometerY = double(data{5});
accelerometerZ = double(data{6});
    
gyroscopeX = double(data{7}); 
gyroscopeY = double(data{8});
gyroscopeZ = double(data{9});

magnetometerX = double(data{10});
magnetometerY = double(data{11});
magnetometerZ = double(data{12});


%% Define Time Stamp
numberOfsamples = cellfun(@length, data(1));
second = zeros(1, numberOfsamples);
Fs = 5;
for i=0:numberOfsamples-1
    second(i+1) = i*(1/Fs);
end

% unixTime = data{2};
% microseconds = data{3};
% 
% unixFirstSec = unixTime(1);
% unixFirstMicroSec = double(microseconds(1));
% timeStampStart = double(unixFirstSec) + 0.000001*unixFirstMicroSec;
% 
% second = double(zeros(numberOfsamples,1));
% for i=1:numberOfsamples
%     second(i) = double(unixTime(i)) + double(microseconds(i))*0.000001 - timeStampStart; 
% end 
% 
% %% Compute Sampling Frequency, Fs
% T = second(2)-second(1); 
% Fs = 1/T;


%% Compute time of walking 
firstTimeSample = 1; 
lastTimeSample = 1; 

for i=1:numberOfsamples 
    if accelerometerZ(i) ~= -10
        firstTimeSample = i; 
        break; 
    end
end
for i=numberOfsamples:-1:1
    if accelerometerZ(i) ~= -10
        lastTimeSample = i;
        break; 
    end
end
timeOfWalking = second(lastTimeSample) - second(firstTimeSample);

if timeOfWalking == 0
    text = 'Timeofwalking = 0. \n No detected movement in z-direction \n Time stamp = signal variations'
    timeOfWalking = second(numberOfsamples)
end 
        