%% Plot individual magnetometer readings
% figure(61) 
% subplot(3,1,1)
% plot(magnetometerX) 
% title('Magnetometer X')
% subplot(3,1,2)
% plot(magnetometerY) 
% title('MagnetometerY')
% subplot(3,1,3)
% plot(magnetometerZ) 
% title('MagnetometerZ')
% imageNameEps = 'magnetometer';
% saveLocation = '/home/hedvik/Dropbox/Masterlivet/Spatial/3000meter/';
% locationSaveEps = strcat(saveLocation, folder(52:79), imageNameEps);
% set(gcf, 'Color', 'w');
% export_fig(locationSaveEps, eps) 

%% Plot horizontal magnetometer readings 
% figure(64) 
% plot(magnetometerX, magnetometerY, '*','MarkerSize', 7,'MarkerFaceColor','r')
% xlabel('MagnetometerX')
% ylabel('MagnetometerY')
% imageNameEps = 'XY-plane';
% saveLocation = '/home/hedvik/Dropbox/Masterlivet/Spatial/3000meter/';
% locationSaveEps = strcat(saveLocation, folder(52:79), imageNameEps);
% set(gcf, 'Color', 'w');
% export_fig(locationSaveEps, eps) 

%% Heading Determination using Magnetometers

% No calibration
magnetometerXcircle = magnetometerX
magnetometerYcircle = magnetometerY

% Remove hard-iron distortions
offsetX(iFile) = min(magnetometerX) + range(magnetometerX)/2;
offsetY(iFile) = min(magnetometerY) + range(magnetometerY)/2;
magnetometerXcircle = magnetometerX - offsetX(iFile);
magnetometerYcircle = magnetometerY - offsetY(iFile);

% Remove hard- and soft-iron distortions
scaleFactorX = max(1, (max(magnetometerY)-min(magnetometerY))/(max(magnetometerX)-min(magnetometerX)) )
scaleFactorY = max(1, (max(magnetometerX)-min(magnetometerX))/(max(magnetometerY)-min(magnetometerY)) )
xOff = (((max(magnetometerX)-min(magnetometerX))/2)-max(magnetometerX))*scaleFactorX  
yOff = (((max(magnetometerY)-min(magnetometerY))/2)-max(magnetometerY))*scaleFactorY  

magnetometerXcircle = scaleFactorX*magnetometerX + xOff;
magnetometerYcircle = scaleFactorY*magnetometerY + yOff;

% Spot turn 
offsetX(iFile) = min(magnetometerX) + range(magnetometerX)/2
offsetY(iFile) = min(magnetometerY) + range(magnetometerY)/2
magnetometerXcircle = magnetometerX - offsetX(iFile);
magnetometerYcircle = magnetometerY - offsetY(iFile);

idealCircleX = 130;
idealCircleY = 130.5;
scaleFactorX = idealCircleX/max(magnetometerXcircle);
scaleFactorY = idealCircleY/max(magnetometerYcircle);
magnetometerXcircle = magnetometerXcircle*scaleFactorX; 
magnetometerYcircle = magnetometerYcircle*scaleFactorY; 

radianer = zeros(numberOfsamples,1);
for i=1:numberOfsamples
    if magnetometerXcircle(i) > 0 && magnetometerYcircle(i) > 0
        radianer(i) = atan(magnetometerYcircle(i)/magnetometerXcircle(i));
    elseif magnetometerXcircle(i) > 0 && magnetometerYcircle(i) < 0
        radianer(i) = atan(magnetometerYcircle(i)/magnetometerXcircle(i))+ 2*pi;
    else
        radianer(i) = atan(magnetometerYcircle(i)/magnetometerXcircle(i)) + pi;
    end
end

radianer = radianer - radianer(1);

figure(65)
plot(magnetometerXcircle, magnetometerYcircle, '*', 'MarkerSize', 7)
xlim([-350 350])
ylim([-350 350])
% xlabel('MagnetometerX')
% ylabel('MagnetometerY')
% imageNameEps = '/runningTrackHorizontalMagneticFieldTotal.eps';
% locationSaveEps = strcat(folder,imageNameEps);
% set(gcf, 'Color', 'w');
% export_fig(locationSaveEps, eps) 
