% Number of steps: numberOfStepsMagTable
% Time when a step has occured: peakLocation
% Step length: estSL
% Direction: degrees

if numberOfStepsDer == 0 
  text = 'Object not moving'
else 
    eastwardDisplacement = zeros(numberOfStepsDer,1);
    northwardDisplacement = zeros(numberOfStepsDer,1);

    % for peak i,
    for i=1:numberOfStepsMag
        eastwardDisplacement(i) = estSL(1)*cos(radianer(peakLocation(i)));
        northwardDisplacement(i) = estSL(1)*sin(radianer(peakLocation(i)));
    end
          
    prevPositionX = estSL(1)*cos(radianer(firstTimeSample));
    prevPositionY = estSL(1)*sin(radianer(firstTimeSample));
    
    newPositionX = zeros(numberOfStepsDer,1); 
    newPositionY = zeros(numberOfStepsDer,1);  
    
    for i=1:numberOfStepsMag
        newPositionX(i) = prevPositionX + eastwardDisplacement(i);
        prevPositionX = newPositionX(i); 
        newPositionY(i) = prevPositionY + northwardDisplacement(i);
        prevPositionY = newPositionY(i);
    end
    
    newPositionX = newPositionX - newPositionX(1);
    newPositionY = newPositionY - newPositionY(1);
    
    figure(81)
    plot(newPositionX, newPositionY, newPositionX(1), newPositionY(1), 'r*', newPositionX(length(newPositionX)), newPositionY(length(newPositionY)), 'r*')
    hold on;
%     imageNameEps = '/runningTrackInertialNavigationTotal.eps';
%     locationSaveEps = strcat(folder,imageNameEps);
%     set(gcf, 'Color', 'w');
%     export_fig(locationSaveEps, eps) 
    
end

