%% Init 
clc, clear; 

% EDIT!!!  
runPanTompkins = 1; % 1 = run, 0 = don't run 
runStepDetection = 1; 
runRealSteps = 1; % 0 = no txt file for counted real steps 
    realStepsTxt = 'realStepsStraightLineFemale.txt'; % Textfile real # steps 
    walkingDistance = 28; % meter
runStepLength = 1; 
runHeadingDetermination =1; 
runSaveTableToLatex = 0; 

fileList = uipickfiles; % GUI for selecting test track log(s)
nFiles = length(fileList); % Number of selected test track log(s)

%% Variable Decleration 
nameSpatialLog = cell(nFiles,1); 

% Variable declaration step detection
if runPanTompkins == 1 || runStepDetection == 1
    numberOfTestTrackTable = zeros(nFiles,1);
    numberOfStepsMagTable = zeros(nFiles,1);
    numberOfStepsDerTable = zeros(nFiles,1);
    numberOfStepsSqrTable = zeros(nFiles,1);
    numberOfStepsMWTable = zeros(nFiles,1);
    workspaceVariablesTable = zeros(nFiles,10);
end

% Variable declaration step length estimation 
if runStepLength == 1
    accelerationVariance = zeros(nFiles, 1); 
    estSL = zeros(nFiles, 1);
    slopeWF = 0.2621;
    slopeAV = 0.0141;
    interceptWF = 0.2632;
    interceptAV = 0.6517;
    k_wf = 0.99;
    k_av = 0.01;
end 

if runHeadingDetermination == 1
    originX = zeros(nFiles,1);
    originY = zeros(nFiles,1);
    %estHeading= zeros(nFiles, 1); 
end

% Import # steps from textfile and calculate real step length
if (runRealSteps ==1)
    realSteps = importdata(realStepsTxt);
    realSL = walkingDistance./realSteps;
    testTrackWalkingFrequency = zeros(nFiles,1);
end
importFile = '/RawSensors.csv'; % Sensor readings

%% Inertial Navigation System: 
%Open one test track log file at a time, detect steps, save plots and data. Repeat for all selected test track logs.  
for iFile=1:nFiles
    
    % Open&Read Test Track 
    folder = fileList{iFile};
    ftoread = strcat(folder,importFile);
    fid = fopen(ftoread, 'r'); 
    data = textscan(fid, '%s%d%d%d%d%d%d%d%d%d%d%d%d%d%d', 'HeaderLines', 1, 'Delimiter', ',');
    fclose(fid);
    
    numberOfTestTrackTable(iFile) = iFile;
    collectRelevantSensorData
        
     % Run Step Detection Algorithm    
    if runStepDetection == 1 
        stepDetection
        %plottingSD 
        %saveData 
    end
    if runPanTompkins == 1
        panTompkins
        %plottingPT 
        %saveDataPT
    end
    
    
    if numberOfStepsDer == 0 
        text = 'No detected peaks = estimated step length is zero'
        estSLE = 0;
    else
        % Calculate acceleration variance and walking frequency
        accelerationVariance(iFile) = var(magnitude);
        testTrackWalkingFrequency(iFile) = numberOfStepsDer/timeOfWalking;
        stepLength
    end
    headingDetermination
    inertialNavigation
    %plotting
end 
   
%% Calculate pre-learned step length parameters 
%stepLengthParameters

%% Calculate Results 
stepDetectionResults
stepLengthResults
