%% CURVE FITTING - WALKING FREQUENCY 
% 1: Use polyfit to compute a linear regression that predicts y from x:
fittingWF = polyfit(testTrackWalkingFrequency, realSL, 1); 
slopeWF = fittingWF(1)
interceptWF = fittingWF(2)

% 2: Call polyval to use p to predict y
yfitWF = polyval(fittingWF,testTrackWalkingFrequency); 
% yfitWF = fittingWF(1)*x + fittingWF(2)

% 3: Compute the residual values as a vector signed numbers:
yresidWF = realSL - yfitWF;

% 4: Square the residuals and total them obtain the residual sum of squares:
SSresidWF = sum(yresidWF.^2);

% 5: Compute the total sum of squares of y by multiplying the variance of y by the number of observations minus 1:
SStotalWF = (length(realSL)-1)* var(realSL); 

% 6: Compute R2 using the formula given in the introduction of this topic:
rsqWF = 1 - SSresidWF/SStotalWF

figure(51)
plot(testTrackWalkingFrequency, yfitWF)
hold on
plot(testTrackWalkingFrequency, realSL, '*r','MarkerSize', 7)
xlabel('walking frequency (Hz)')
ylabel('step length [m]')

% imageNameEps = 'walkingFrequencyVSStepLength.eps';
% saveLocation = '/home/hedvik/Dropbox/Masterlivet/Kile/gfx/';
% locationSaveEps = strcat(saveLocation,imageNameEps);
% set(gcf, 'Color', 'w');
% export_fig(locationSaveEps, eps)

%% CURVE FITTING - ACCELERATION VARIANCE 
% 1: 
fittingAV = polyfit(accelerationVariance, realSL, 1); 
slopeAV = fittingAV(1)
interceptAV = fittingAV(2)

% 2: Call polyval to use p to predict y, calling the result yfit:
yfitAV = polyval(fittingAV,accelerationVariance); 
% yfit = fitting(1)*x + p(2)

% 3: Compute the residual values as a vector signed numbers:
yresidAV = realSL - yfitAV;

% 4: Square the residuals and total them obtain the residual sum of squares:
SSresidAV = sum(yresidAV.^2);

% 5: Compute the total sum of squares of y by multiplying the variance of y by the number of observations minus 1:
SStotalAV = (length(realSL)-1)* var(realSL); 

% 6: Compute R2 using the formula given in the introduction of this topic:
rsqAV = 1 - SSresidAV/SStotalAV

figure(52)
plot(accelerationVariance, yfitAV)
hold on
plot(accelerationVariance, realSL, '*r','MarkerSize', 7)
xlabel('acceleration variance')
ylabel('step length [m]')

% imageNameEps = 'accelerationVarianceVSStepLength.eps';
% saveLocation = '/home/hedvik/Dropbox/Masterlivet/Kile/gfx/';
% locationSaveEps = strcat(saveLocation,imageNameEps);
% set(gcf, 'Color', 'w');
% export_fig(locationSaveEps, eps)